﻿using System;
using System.Windows.Forms;
using AddinExpress.MSO;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace ReplyAllExplorer
{
    /// <summary>
    /// Add-in Express Outlook Item Events Class
    /// </summary>
    public class ReplyAllChecker : AddinExpress.MSO.ADXOutlookItemEvents
    {
        public ReplyAllChecker(AddinExpress.MSO.ADXAddinModule module)
            : base(module)
        {
        }

        private string getSubject()
        {
            if (!this.IsConnected) return "''";
            // Get 'this.ItemObj.Subject;' via late binding 
            string subject = "'" +
                this.ItemObj.GetType().InvokeMember("Subject",
                    System.Reflection.BindingFlags.GetProperty,
                    null, this.ItemObj, null).ToString()
                + "'";
            return subject;
        }

        public override void ProcessReply(object response, AddinExpress.MSO.ADXCancelEventArgs e)
        {
            Debug.Print("The  Reply event of the item with the subject " + getSubject() + " has occurred.");
            if (this.ItemObj is Outlook.MailItem)
            {
                Outlook.MailItem mail = this.ItemObj as Outlook.MailItem;
                Outlook.Recipients recipients = mail.Recipients;
                if (recipients.Count > 1)
                {
                    if (MessageBox.Show("Did you mean to click 'Reply All' ?", this.Module.AddinName + " sample project", MessageBoxButtons.YesNo) == DialogResult.Yes)
                    {
                        Debug.Print("The Reply action is cancelled by the user.");
                        e.Cancel = true;
                    }
                }
                Marshal.ReleaseComObject(recipients);
            }
        }

        # region non-used events

        public override void ProcessAttachmentAdd(object attachment)
        {
            // TODO: Add some code
        }

        public override void ProcessAttachmentRead(object attachment)
        {
            // TODO: Add some code
        }

        public override void ProcessBeforeAttachmentSave(object attachment, AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessBeforeCheckNames(AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessClose(AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessCustomAction(object action, object response, AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessCustomPropertyChange(string name)
        {
            // TODO: Add some code
        }

        public override void ProcessForward(object forward, AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessOpen(AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessPropertyChange(string name)
        {
            // TODO: Add some code
        }

        public override void ProcessRead()
        {
            // TODO: Add some code
        }

        public override void ProcessReplyAll(object response, AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessSend(AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessWrite(AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessBeforeDelete(object item, AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessAttachmentRemove(object attachment)
        {
            // TODO: Add some code
        }

        public override void ProcessBeforeAttachmentAdd(object attachment, AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessBeforeAttachmentPreview(object attachment, AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessBeforeAttachmentRead(object attachment, AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessBeforeAttachmentWriteToTempFile(object attachment, AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessUnload()
        {
            // TODO: Add some code
        }

        public override void ProcessBeforeAutoSave(AddinExpress.MSO.ADXCancelEventArgs e)
        {
            // TODO: Add some code
        }

        public override void ProcessBeforeRead()
        {
            // TODO: Add some code
        }

        public override void ProcessAfterWrite()
        {
            // TODO: Add some code
        }

        # endregion

    }
}

